Name:          proxytoys
Version:       0.2.1
Release:       %mkrel 1
Summary:       ProxyToys
Group:         Development/Java
License:       BSD
Url:           http://proxytoys.codehaus.org/
Source0:       http://dist.codehaus.org/proxytoys/distributions/proxytoys-src-%{version}.zip
# svn co http://svn.codehaus.org/proxytoys/tags/0.2.1/website website
# tar czf proxytoys-0.2.1-website-src-svn.tar.gz website
Source1:       proxytoys-%{version}-website-src-svn.tar.gz
Source2:       proxytoys-%{version}.pom
Patch0:        proxytoys-0.2.1-build_xml.patch
BuildRequires: ant
BuildRequires: ant-junit
BuildRequires: cglib21
BuildRequires: freemarker
BuildRequires: jakarta-oro
BuildRequires: java-devel
BuildRequires: jmock1
BuildRequires: jpackage-utils
BuildRequires: junit
# TODO BuildRequires: sitemesh
BuildRequires: xpp3
BuildRequires: xstream
Requires:      cglib21
Requires:      jpackage-utils
Requires:      xstream
BuildArch:     noarch

%description
ProxyToys provides a collection of toys acting as factories for creating "special" proxies such as:

* Decorators - for simple AOP-like chained method interception
* Delegates - for method invocation on a delegate object, that might have different type
* Dispatcher proxy - single proxy instance dispatching method calls to different object with separate types
* Echo proxy - for tracing method calls
* Failover objects - fails over to a next object in case of exception
* Hot swapping proxy - allows implementation hiding that can be swapped, and mutual dependencies
* Multicasting objects - for multicasting a method invocation to multiple objects
* Null objects - for default implementations of classes that do nothing at all
* Pool - for a pool implemntation with proxied objects that return automatically to the pool

%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      %{name} = %{version}-%{release} 
Requires:      jpackage-utils

%description javadoc
ProxyToys.

This package contains javadoc for %{name}

%prep
%setup -q -c
%patch0 -p0

tar -xf %{SOURCE1}

for j in $(find . -name "*.jar"); do
   mv $j $j.no
done
for j in $(find . -name "*.class"); do
   rm -f $j
done

pushd lib
  ln -s $(build-classpath cglib21) cglib-nodep.jar
  ln -s $(build-classpath jmock1) jmock-1.0.1.jar
  ln -s $(build-classpath junit) junit-3.8.1.jar
  ln -s $(build-classpath xpp3) xpp3-1.1.3.4-RC8_min.jar
  ln -s $(build-classpath xstream) xstream-1.1.2.jar
popd

pushd website/lib
  ln -s $(build-classpath freemarker) freemarker-2.3.3.jar
  ln -s $(build-classpath oro) oro-2.0.8.jar
# for apidoc
  mv sitemesh-2.2.1.jar.no sitemesh-2.2.1.jar
#  ln -s $(build-classpath sitemesh) sitemesh-2.2.1.jar
popd

%build

export OPT_JAR_LIST=`cat %{_sysconfdir}/ant.d/junit`
export CLASSPATH=
%{ant} test javadoc

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}
install -pm 644 build/proxytoys-%{version}.jar \
  %{buildroot}%{_javadir}/proxytoys-%{version}.jar

mkdir -p %{buildroot}%{_mavenpomdir}
%add_to_maven_depmap proxytoys proxytoys %{version} JPP proxytoys
install -pm 644 %{SOURCE2} %{buildroot}%{_mavenpomdir}/JPP-proxytoys.pom

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}.jar; do
    ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
  done
)

mkdir -p %{buildroot}%{_javadocdir}/proxytoys-%{version}
cp -pr build/website/apidocs/* %{buildroot}%{_javadocdir}/proxytoys-%{version}
ln -s proxytoys-%{version} %{buildroot}%{_javadocdir}/proxytoys

%clean
[ %{buildroot} != / ] && rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%{_javadir}/proxytoys-%{version}.jar
%{_javadir}/proxytoys.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc LICENSE.txt

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/proxytoys-%{version}
%{_javadocdir}/proxytoys



%changelog
* Fri Aug 05 2011 dmorgan <dmorgan> 0.2.1-1.mga2
+ Revision: 131844
- Clean spec file

  + gil <gil>
    - imported package proxytoys


* Sun Jun 26 2011 gil <gil> 0.2.1-0.%%mkrel
- initial rpm